// Copyright (C) 1997 by John P. Weiss
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the Artistic License, included as the file
// "LICENSE" in the source code archive.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// You should have received a copy of the file "LICENSE", containing
// the License John Weiss originally placed this program under.
#include "WorkManDB.h"


// from <linux/cdrom.h>.  Change if necessary.
#define CD_FRAMES           75 /* frames per second */



// Should be enough!
#define MAXCATLEN 65536


// Special version of WorkManDB to access the protected member
// "read_i()"
//
class SpecialWMDB : public WorkManDB
{
   public:
	 SpecialWMDB(char *fname):WorkManDB(fname) {
	    return;
	 }
	 bool read2(Catalog& ct2, int i2) {
	    return read_i(ct2, i2);
	 }
};


// Main routine.
//
int main(int argc, char *argv[])
{
   int i, leadout_idx, oldleadout;

   if(argc < 3)
	 {
	 cout << "Usage: " << argv[0] << " <olddb> <newdb>" << endl;
	 exit(-1);
	 }
   
   SpecialWMDB old(argv[1]);
   WorkManDB fix(argv[2]);
   Catalog cat;

   i=0;
   while( old.read2(cat,i) && (i < MAXCATLEN) )
	 {
	 leadout_idx = cat.len();
	 oldleadout = cat.time(leadout_idx);
	 if( cat.time(leadout_idx-1) > oldleadout )
	    {
	    cout << "Entry #" << i << ": fixing" << endl;
	    cat.setTime(leadout_idx,oldleadout*CD_FRAMES);
	    }
	 else
	    {
	    cout << "Entry #" << i << ": ok" << endl;
	    }
	 fix.add(cat);
	 i++;
	 }

   cout << "Processed " << i-1 << " catalog entries." << endl;
   exit(0);
}

